
TYPO3.Flow - Feature # 33581

Status: Resolved Priority: Should have
Author: Peter Russ Category: Core
Created: 2012-02-01 Assigned To: Sebastian Kurfuerst
Updated: 2012-05-09 Due date:
PHP Version:
Has patch: Yes
Complexity:
Subject: Extend configuration/context
Description

So far FLOW3 context is limited to Development, Testing and Production. 
Further there is no way that operation/admin can add or overule configuration e.g. to set credentials which should not be store in a dev
repro.

FLOW3_SUBSYSTEM
To give more flexibility to the configuration a new environment constant is added FLOW3_SUBSYSTEM:
this could hold e.g. machine or vhost name

If this is set Configuration will be created that way:
Configuration/Settings.yaml
Configuration/<FLOW3_CONTEXT>/Setting.yaml
Configuration/<FLOW3_CONTEXT>/<FLOW3_SUBSYSTEM>.Setting.yaml

The benefit of that is that you can run e.g. Production Context on a machine for staging with slightly different settings e.g. for the
database or a LDAP.

FLOW3_STATIC_CONFIGURATION
Credentials or settings that should be set by operations/admin can be define by providing the absolute path and filename without
'.yaml' in FLOW3_STATIC_CONFIGURATION.

If this is set Configuration will be created that way:
Configuration/Settings.yaml
Configuration/<FLOW3_CONTEXT>/Setting.yaml
Configuration/<FLOW3_CONTEXT>/<FLOW3_SUBSYSTEM>.Setting.yaml
<FLOW3_STATIC_CONFIGURATION>.yaml

Only small changes in Web/index.php, Bootstrap and ConfigurationManager are required.

Patch attached

Associated revisions
Revision 9df55671 - 2012-05-03 17:41 - Sebastian Kurfuerst

[!!!][FEATURE] (Core): Nested FLOW3 Application Contexts

With this change, it is possible to use nested FLOW3 contexts like
"Production/Live" or "Production/Staging/Server1". The main context,
has to be one of "Production", "Development" or "Testing", whereas
arbitrary sub contexts are supported.

If you run in the context "Production/Staging/Server1", the configuration
is inherited in the following way (from most specific to most general):
- Production/Staging/Server1
- Production/Staging
- Production
- as a fallback, the, non-context-specific configuration is used

This change is breaking in the following cases:

- You called TYPO3\FLOW3\Core\Bootstrap::getContext() or
  TYPO3\FLOW3\Object\ObjectManagerInterface::getContext()

In this case, not the context string is returned anymore, but instead
  the TYPO3\FLOW3\Core\ApplicationContext object. It can be cast to a string to
  get the old behavior back; but usually you instead want to call
  $context->isDevelopment(), $context->isProduction() or $context->isTesting().

- You wrote your own cache backend
The cache backend constructor now expects the $context object to be of type
  TYPO3\FLOW3\Core\ApplicationContext.

Additionally, we removed some leftovers from the configuration manager,
especially Signals/Slots configuration as this is not used anymore.

Releases: 1.1
Resolves: #33581
Change-Id: I3ffe0f98b0c92df41edaa15c7d895422aab28411

Revision 4fe6851b - 2012-05-09 15:36 - Karsten Dambekalns

[TASK] Small docblock cleanup to Bootstrap

Change-Id: I594f7ab42ac59e95baec39011554eaba6a304293
Related: #33581
Releases: 1.1

Revision cb141c73 - 2012-05-30 16:39 - Karsten Dambekalns

[TASK] Create configuration directories only on save

The configuration directories for cached configuration were created
inside the constructor of the ConfigurationManager. This caused the
unit test to create directories outside the VFS. Moving the creation
to the saveConfigurationCache method fixes that. Additionally cleans
up some unit tests related to ApplicationContext and
ConfigurationManager.

Change-Id: I90d3f1410314fa39836fdde2a28c911a173a630d
Related: #33581
Releases: 1.1, 1.2

Revision 2a228475 - 2012-05-30 16:43 - Karsten Dambekalns
[TASK] Create configuration directories only on save

The configuration directories for cached configuration were created
inside the constructor of the ConfigurationManager. This caused the
unit test to create directories outside the VFS. Moving the creation
to the saveConfigurationCache method fixes that. Additionally cleans
up some unit tests related to ApplicationContext and
ConfigurationManager.

Change-Id: I90d3f1410314fa39836fdde2a28c911a173a630d
Related: #33581
Releases: 1.1, 1.2

History
#1 - 2012-02-01 10:34 - Peter Russ
- File 33581.patch added

#2 - 2012-02-01 10:58 - Karsten Dambekalns
- Project changed from TYPO3 Flow Base Distribution to TYPO3.Flow

#3 - 2012-02-01 10:59 - Karsten Dambekalns
- Category set to Core
- Target version deleted (1.1)
- Has patch set to No

#4 - 2012-02-01 11:35 - Peter Russ
- Target version set to 1.1

why is patch set to no although there is one attached?

#5 - 2012-02-01 11:37 - Peter Russ
- Target version deleted (1.1)

#6 - 2012-02-01 12:40 - Karsten Dambekalns
- Has patch changed from No to Yes

Peter Russ wrote:

why is patch set to no although there is one attached?

By accident, it's the default it seems. No intended change. :)

#7 - 2012-02-01 12:42 - Karsten Dambekalns

Regarding the FLOW3_STATIC_CONFIGURATION idea, please check https://review.typo3.org/5731 and see if that would work for you.
#8 - 2012-02-01 14:33 - Peter Russ

As operation might use different versioning system this will not work for us. Further it requires to restart the php-fpm to activate the settings. This is not
really practicable. Further it seems to be a solution to set a few parameters.
I discussed with our operations with the result that our solution would be prefered.

#9 - 2012-02-01 23:56 - Chris Zepernick

I have to agree with Peter there,... passwords and stuff in environment of the v-host is a big no no in most enterprise scenarios, and most likely will not
be approved by security audit.

I also would prefer Peters solution on the one hand because of security reasons, on ther other because it can provide us with an option for A/B Testing
and stuff, without the hazzel to need to have the config seperated from the project to do so.

Our setup at the moment:

1. Development
2. Continous Deployment Development
-------------------------------------------
3. System Integration (For Release Build)
4. Testing (Unit Testing and Stuff)
-------------------------------------------
5. Production
6. A/B Closed User group testing of new Features

We currently work with a of staff of 10 Devs and 2 Admins at one of Telekoms Top 60 Intranet Solutions, of which FLOW3 is a Core component serving
as the middleware to our TYPO3 systems.

Regards

Chris

#10 - 2012-02-07 12:00 - Peter Russ
- File 33581-V2.patch added
- File missing_flow3.patch added

Added new version of patch as flow3.php patched part was missing

#11 - 2012-04-26 12:13 - Sebastian Kurfuerst
- Status changed from New to Accepted
- Assigned To set to Sebastian Kurfuerst

I'm currently working on this one.

Main question is how to call this "subSystem":

    -  FLOW3_SUBSYSTEM
    -  FLOW3_SUBCONTEXT
    -  FLOW3_TARGET
    -  ... your idea here

#12 - 2012-04-26 19:03 - Peter Russ

As we are using this already on several servers in production we would prefer to stay with
FLOW3_SUBSYSTEM (similar we use in TYPO3 ;-)

Example: We are in the production context and have there systems with different tasks:
one for system integration testing, an other for approval or one for beta.

That the reason we we decided to use FLOW3_SUBSYSTEM.

#13 - 2012-04-26 22:06 - Karsten Dambekalns

Since any new context should inherit from either production or development, I'd rather like to see FLOW3_CONTEXT get the ability to be fed with
something like Development, Production/Staging and Production/Live.

Any splitting into FLOW3_CONTEXT and FLOW3_SUBSYSTEM (and where is it a subsystem of FLOW3?) is more complexity IMHO.

#14 - 2012-04-27 07:20 - Gerrit Code Review
- Status changed from Accepted to Under Review

Patch set 1 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/10808

#15 - 2012-04-27 08:01 - Gerrit Code Review

Patch set 2 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/10808

#16 - 2012-04-27 08:24 - Gerrit Code Review

Patch set 3 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/10808

#17 - 2012-04-27 11:44 - Gerrit Code Review

Patch set 4 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/10808

#18 - 2012-04-27 11:44 - Gerrit Code Review

Patch set 5 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/10808
#19 - 2012-04-27 11:49 - Gerrit Code Review

Patch set 6 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/10808

#20 - 2012-04-27 13:39 - Gerrit Code Review

Patch set 7 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/10808

#21 - 2012-04-27 15:11 - Gerrit Code Review

Patch set 8 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/10808

#22 - 2012-05-02 11:33 - Gerrit Code Review

Patch set 9 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/10808

#23 - 2012-05-03 16:10 - Gerrit Code Review

Patch set 10 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/10808

#24 - 2012-05-03 16:19 - Gerrit Code Review

Patch set 11 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/10808

#25 - 2012-05-03 16:35 - Gerrit Code Review

Patch set 12 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/10808

#26 - 2012-05-03 17:43 - Gerrit Code Review

Patch set 13 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/10808

#27 - 2012-05-04 02:38 - Sebastian Kurfuerst
- Status changed from Under Review to Resolved
- % Done changed from 80 to 100
Applied in changeset commit:9df5567135e42e1ab312f9a560c3eed382517c83.

#28 - 2012-05-09 15:28 - Karsten Dambekalns
- Target version set to 1.1 beta 1

Files
33581.patch 9.3 kB 2012-02-01 Peter Russ
33581-V2.patch 10.4 kB 2012-02-07 Peter Russ
missing_flow3.patch 1.1 kB 2012-02-07 Peter Russ
